
/**** LCD PARTS ****/
// 7 CHAR
#define _A7		LCDDATA20 = 0x20;   
#define _B7		LCDDATA14 = 0x20;   
#define _C7		LCDDATA8  = 0x20;   
#define _D7		LCDDATA2  = 0x20;   	 
#define _E7  	LCDDATA8  = 0x80;   
#define _F7  	LCDDATA14 = 0x80;   
#define _G7   	LCDDATA14 = 0x40;   
#define _M7   	LCDDATA8  = 0x10;   
#define _H7   	LCDDATA20 = 0x40;   
#define _J7   	LCDDATA20 = 0x10;      
#define _K7   	LCDDATA14 = 0x10;   
#define _N7   	LCDDATA2  = 0x10;   
#define _P7   	LCDDATA2  = 0x40;   
#define _Q7   	LCDDATA8  = 0x40;   

#define _all_7_off 	LCDDATA8 &= ~0xF0; LCDDATA2 &= ~0xF0; LCDDATA14 &= ~0xF0; LCDDATA20 &= ~0xF0;
#define clr7		LCDDATA8 &= ~0xF0; LCDDATA2 &= ~0xF0; LCDDATA14 &= ~0xF0; LCDDATA20 &= ~0xF0;

// 6 CHAR
#define _A6		LCDDATA21 = 0x02;   
#define _B6		LCDDATA15 = 0x02;   
#define _C6		LCDDATA9  = 0x02;   
#define _D6		LCDDATA3  = 0x02;   	 
#define _E6  	LCDDATA9  = 0x08;   
#define _F6  	LCDDATA15 = 0x08;   
#define _G6   	LCDDATA15 = 0x04;   
#define _M6   	LCDDATA9  = 0x01;   
#define _H6   	LCDDATA21 = 0x04;   
#define _J6   	LCDDATA21 = 0x01;      
#define _K6   	LCDDATA15 = 0x01;   
#define _N6   	LCDDATA3  = 0x01;   
#define _P6   	LCDDATA3  = 0x04;   
#define _Q6   	LCDDATA9  = 0x04;   

#define _all_6_off 	LCDDATA3 &= ~0x0F; LCDDATA9 &= ~0x0F; LCDDATA15 &= ~0x0F; LCDDATA21 &= ~0x0F;
#define clr6 		LCDDATA3 &= ~0x0F; LCDDATA9 &= ~0x0F; LCDDATA15 &= ~0x0F; LCDDATA21 &= ~0x0F;

// 5 CHAR
#define _A5		LCDDATA21 = 0x20;   
#define _B5		LCDDATA15 = 0x20;   
#define _C5		LCDDATA9  = 0x20;   
#define _D5		LCDDATA3  = 0x20;   	 
#define _E5  	LCDDATA9  = 0x80;   
#define _F5  	LCDDATA15 = 0x80;   
#define _G5   	LCDDATA15 = 0x40;   
#define _M5   	LCDDATA9  = 0x10;   
#define _H5   	LCDDATA21 = 0x40;   
#define _J5   	LCDDATA21 = 0x10;      
#define _K5   	LCDDATA15 = 0x10;   
#define _N5   	LCDDATA3  = 0x10;   
#define _P5   	LCDDATA3  = 0x40;   
#define _Q5   	LCDDATA9  = 0x40;  

#define _all_5_off 	LCDDATA9 &= ~0xF0; LCDDATA3 &= ~0xF0; LCDDATA15 &= ~0xF0; LCDDATA21 &= ~0xF0; 
#define clr5 		LCDDATA9 &= ~0xF0; LCDDATA3 &= ~0xF0; LCDDATA15 &= ~0xF0; LCDDATA21 &= ~0xF0; 

// 4 CHAR
#define _A4		LCDDATA22 = 0x02;   
#define _B4		LCDDATA16 = 0x02;   
#define _C4		LCDDATA10 = 0x02;   
#define _D4		LCDDATA4  = 0x02;   	 
#define _E4  	LCDDATA10 = 0x08;   
#define _F4  	LCDDATA16 = 0x08;   
#define _G4   	LCDDATA16 = 0x04;   
#define _M4   	LCDDATA10 = 0x01;   
#define _H4   	LCDDATA22 = 0x04;   
#define _J4   	LCDDATA22 = 0x01;      
#define _K4   	LCDDATA16 = 0x01;   
#define _N4   	LCDDATA4  = 0x01;   
#define _P4   	LCDDATA4  = 0x04;   
#define _Q4   	LCDDATA10 = 0x04;   

#define _all_4_off 	LCDDATA10 &= ~0x0F; LCDDATA4 &= ~0x0F; LCDDATA16 &= ~0x0F; LCDDATA22 &= ~0x0F;
#define clr4 		LCDDATA10 &= ~0x0F; LCDDATA4 &= ~0x0F; LCDDATA16 &= ~0x0F; LCDDATA22 &= ~0x0F;

// 3 CHAR
#define _A3		LCDDATA22 = 0x20;   
#define _B3		LCDDATA16 = 0x20;   
#define _C3		LCDDATA10 = 0x20;   
#define _D3		LCDDATA4  = 0x20;   	 
#define _E3  	LCDDATA10 = 0x80;   
#define _F3  	LCDDATA16 = 0x80;   
#define _G3   	LCDDATA16 = 0x40;   
#define _M3   	LCDDATA10 = 0x10;   
#define _H3   	LCDDATA22 = 0x40;   
#define _J3   	LCDDATA22 = 0x10;      
#define _K3   	LCDDATA16 = 0x10;   
#define _N3   	LCDDATA4  = 0x10;   
#define _P3   	LCDDATA4  = 0x40;   
#define _Q3   	LCDDATA10 = 0x40;   

#define _all_3_off 	LCDDATA10 &= ~0xF0; LCDDATA4 &= ~0xF0; LCDDATA16 &= ~0xF0; LCDDATA22 &= ~0xF0;
#define clr3 		LCDDATA10 &= ~0xF0; LCDDATA4 &= ~0xF0; LCDDATA16 &= ~0xF0; LCDDATA22 &= ~0xF0;

// 2 CHAR
#define _A2		LCDDATA23 = 0x02;   
#define _B2		LCDDATA17 = 0x02;   
#define _C2		LCDDATA11 = 0x02;   
#define _D2		LCDDATA5  = 0x02;   	 
#define _E2  	LCDDATA11 = 0x08;   
#define _F2  	LCDDATA17 = 0x08;   
#define _G2   	LCDDATA17 = 0x04;   
#define _M2   	LCDDATA11 = 0x01;   
#define _H2   	LCDDATA23 = 0x04;   
#define _J2   	LCDDATA23 = 0x01;      
#define _K2   	LCDDATA17 = 0x01;   
#define _N2   	LCDDATA5  = 0x01;   
#define _P2   	LCDDATA5  = 0x04;   
#define _Q2   	LCDDATA11 = 0x04;   

#define _all_2_off 	LCDDATA11 &= ~0x0F; LCDDATA5 &= ~0x0F; LCDDATA17 &= ~0x0F; LCDDATA23 &= ~0x0F;
#define clr2 		LCDDATA11 &= ~0x0F; LCDDATA5 &= ~0x0F; LCDDATA17 &= ~0x0F; LCDDATA23 &= ~0x0F;

// 1 CHAR
#define _A1		LCDDATA23 = 0x20;   
#define _B1		LCDDATA17 = 0x20;   
#define _C1		LCDDATA11 = 0x20;   
#define _D1		LCDDATA5  = 0x20;   	 
#define _E1  	LCDDATA11 = 0x80;   
#define _F1  	LCDDATA17 = 0x80;   
#define _G1   	LCDDATA17 = 0x40;   
#define _M1   	LCDDATA11 = 0x10;   
#define _H1   	LCDDATA23 = 0x40;   
#define _J1   	LCDDATA23 = 0x10;      
#define _K1   	LCDDATA17 = 0x10;   
#define _N1   	LCDDATA5  = 0x10;   
#define _P1   	LCDDATA5  = 0x40;   
#define _Q1   	LCDDATA11 = 0x40;   

#define _all_1_off 	LCDDATA11 &= ~0xF0; LCDDATA5 &= ~0xF0; LCDDATA17 &= ~0xF0; LCDDATA23 &= ~0xF0;
#define clr1		LCDDATA11 &= ~0xF0; LCDDATA5 &= ~0xF0; LCDDATA17 &= ~0xF0; LCDDATA23 &= ~0xF0;

#define _DOT1	LCDDATA2  = 0x80;  
#define _DOT2	LCDDATA3  = 0x08; 
#define _DOT3	LCDDATA3  = 0x80;
#define _DOT4	LCDDATA4  = 0x08; 
#define _DOT5	LCDDATA4  = 0x80; 
#define _DOT6	LCDDATA5  = 0x08; 
#define	DOT_off LCDDATA2 &= ~0x80; LCDDATA3 &= ~0x08; LCDDATA3  &= ~0x80; LCDDATA4 &= ~0x08; LCDDATA4 &= ~0x80; LCDDATA5 &= ~0x08; 

#define _DDOT1	LCDDATA21 = 0x10; 
#define _DDOT2	LCDDATA21 = 0x80;
#define _DDOT3	LCDDATA22 = 0x10; 
#define _DDOT4	LCDDATA22 = 0x80;
#define _DDOT5	LCDDATA23 = 0x08; 
#define DDOT_off 	LCDDATA21 &= ~0x10; LCDDATA21 &= ~0x80; LCDDATA22 &= ~0x10; LCDDATA22 &= ~0x80; LCDDATA23 &= ~0x08; 

#define _OLIMEX	LCDDATA20 = 0x80; 
#define _MINUS	LCDDATA5  = 0x80; 
#define _PLUS	LCDDATA23 = 0x80;
#define sing2_off	LCDDATA20 &= ~0x80; LCDDATA5 &= ~0x80; LCDDATA23 &= ~0x80;


/**** CLK segments ****/
//lcd small 1
#define _a1  		LCDDATA0  = 0x02;
#define _b1  		LCDDATA0  = 0x01; 
#define _c1  		LCDDATA12 = 0x01;
#define _d1  		LCDDATA18 = 0x01;
#define _e1  		LCDDATA12 = 0x02; 
#define _f1  		LCDDATA6  = 0x02; 
#define _g1  		LCDDATA6  = 0x01; 

//lcd small 2
#define _a2  		LCDDATA0  = 0x08; 
#define _b2  		LCDDATA0  = 0x04;	 
#define _c2  		LCDDATA12 = 0x04;
#define _d2  		LCDDATA18 = 0x04; 
#define _e2  		LCDDATA12 = 0x08;
#define _f2  		LCDDATA6  = 0x08;
#define _g2  		LCDDATA6  = 0x04;


//lcd small 3
#define _a3  		LCDDATA0  = 0x10; 
#define _b3  		LCDDATA6  = 0x10; 
#define _c3  		LCDDATA12 = 0x10; 
#define _d3  		LCDDATA18 = 0x20; 
#define _e3  		LCDDATA12 = 0x20;
#define _f3  		LCDDATA0  = 0x20;
#define _g3  		LCDDATA6  = 0x20;


//lcd small 4
#define _a4  		LCDDATA0  = 0x40;
#define _b4  		LCDDATA6  = 0x40; 
#define _c4  		LCDDATA12 = 0x40;
#define _d4  		LCDDATA18 = 0x80;
#define _e4  		LCDDATA12 = 0x80;
#define _f4  		LCDDATA0  = 0x80;
#define _g4  		LCDDATA6  = 0x80;

#define _dot1 		LCDDATA18 = 0x02;
#define _dot2 		LCDDATA18 = 0x10;
#define _dot3 		LCDDATA18 = 0x40;
#define _ddot 		LCDDATA18 = 0x08;
#define _dot_off	LCDDATA18 &= ~0x5A;

#define _all_clk_off 	LCDDATA0 = 0; LCDDATA6 = 0; LCDDATA12 = 0; LCDDATA18 &= ~0xA5; 
#define clk_off 		LCDDATA0 = 0; LCDDATA6 = 0; LCDDATA12 = 0; LCDDATA18 &= ~0xA5; 

/**** arrow segments ****/
#define _arr_l  	LCDDATA1 	= 0x01;
#define _arr_r		LCDDATA13 	= 0x01;
#define _arr_d		LCDDATA19 	= 0x01;
#define _arr_u		LCDDATA7 	= 0x01;
#define _arr_off 	LCDDATA1 &= ~0x01; LCDDATA13 &= ~0x01; LCDDATA19 &= ~0x01; LCDDATA7 &= ~0x01;

#define _lbat_start_end		LCDDATA1 	= 0x02;
#define _lbat_1				LCDDATA19 	= 0x02;
#define _lbat_2				LCDDATA13 	= 0x02;
#define _lbat_3				LCDDATA7 	= 0x02;
#define lbat_off	LCDDATA1 &= ~0x02; LCDDATA19 &= ~0x02; LCDDATA13 &= ~0x02; LCDDATA7 &= ~0x02;

#define _progress_end		LCDDATA2 	= 0x01;
#define _progress_1			LCDDATA14 	= 0x04;
#define _progress_2			LCDDATA8 	= 0x04;
#define _progress_3			LCDDATA2 	= 0x04;
#define _progress_4			LCDDATA2 	= 0x02;
#define _progress_5			LCDDATA8 	= 0x02;
#define _progress_6			LCDDATA14 	= 0x02;
#define _progress_7			LCDDATA20 	= 0x02;
#define _progress_8			LCDDATA20 	= 0x01;
#define _progress_9			LCDDATA14 	= 0x01;
#define _progress_10		LCDDATA8 	= 0x01;
#define _progress_start		LCDDATA20 	= 0x04;
#define _progress_off		LCDDATA2 &= ~0x07; LCDDATA8 &= ~0x07;  LCDDATA14 &= ~0x07; LCDDATA20 &= ~0x07; 


#define _F	LCDDATA2 	= 0x08;
#define _H	LCDDATA8 	= 0x08;
#define _m	LCDDATA14 	= 0x08;
#define _u	LCDDATA20 	= 0x08;
#define sing1_off 	LCDDATA2 &= ~0x08; LCDDATA8 &= ~0x08; LCDDATA14 &= ~0x08; LCDDATA20 &= ~0x08;

// test lcd segment
void TestLCD(void);
void TestExt(void);











